#include SFSECURITY.H

loSecurity = newobject('SFSecurity', 'SFSecurity.vcx')
if not loSecurity.Setup()
	messagebox(loSecurity.cErrorMessage)
	return
endif not loSecurity.Setup()

with loSecurity

* Set the key seed values.

	.cKeySeed1 = 'FoxTalk provides'
	.cKeySeed2 = 'great value'
	.cKeySeed3 = 'for Visual'
	.cKeySeed4 = 'FoxPro developers.'
	.cKeySeed5 = 'Fox Rocks!'

* Create the roles we'll need.

	.oRoles.Add('Administrators')
	.oRoles.Add('Everyone')

* Create the ADMIN user.

	loUser           = .oUsers.Add('ADMIN')
	loUser.Password  = .Encrypt('Testing123')
	loUser.FirstName = 'Administrative'
	loUser.LastName  = 'User'

* Create the DHENNIG user.

	loUser           = .oUsers.Add('DHENNIG')
	loUser.Password  = .Encrypt('DumbPassword')
	loUser.FirstName = 'Doug'
	loUser.LastName  = 'Hennig'

* Add the ADMIN user to the various roles.

	loUser = .oUsers.Item('ADMIN')
	loRole = .oRoles.Item('Administrators')
	.AddUserToRole(loUser.ID, loRole.ID)
	loRole = .oRoles.Item('Everyone')
	.AddUserToRole(loUser.ID, loRole.ID)

* Add the DHENNIG user to the appropriate roles.

	loUser = .oUsers.Item('DHENNIG')
	loRole = .oRoles.Item('Everyone')
	.AddUserToRole(loUser.ID, loRole.ID)

* See which roles are available for DHENNIG, then add and remove the
* Administrators role.

	loUser      = .oUsers.Item('DHENNIG')
	loAdminRole = .oRoles.Item('Administrators')
	messagebox('DHENNIG is ' + ;
		iif(.IsUserInRole(loUser.ID, loAdminRole.ID), '', 'not ') + ;
		'in the Administrators role.')
	.AddUserToRole(loUser.ID, loAdminRole.ID)
	messagebox('DHENNIG is ' + ;
		iif(.IsUserInRole(loUser.ID, loAdminRole.ID), '', 'not ') + ;
		'in the Administrators role.')
	loRoles = .GetRolesForUser(loUser.ID)
	lcRoles = ''
	for each loRole in loRoles
		lcRoles = lcRoles + iif(empty(lcRoles), '', ', ') + loRole.Name
	next loRole
	messagebox('DHENNIG is in the following roles:' + chr(13) + chr(13) + ;
		lcRoles)
	.RemoveUserFromRole(loUser.ID, loAdminRole.ID)
	messagebox('DHENNIG is ' + ;
		iif(.IsUserInRole(loUser.ID, loAdminRole.ID), '', 'not ') + ;
		'in the Administrators role.')
endwith
